#ifndef PGM_H
#define PGM_H

typedef struct {
	int		ptype;	// magic number (integer part of 'P5')
	int		w;	// width
	int		h;	// height
	int		bpp;	// bytes per pixel (1 or 3)
	int		max;	// max color (usually 255)
	char		*name; 	// filename
	float		*gpix;	// the pixels, stored as 1D array
} PGM;

PGM	*pgm_alloc(int r, int c);
void     pgm_free(PGM **img);
PGM     *pgm_read(const char *file);
int      pgm_write(PGM *img, const char *file);
void     pgm_white(PGM *img);

#endif
