#ifndef PPM_H
#define PPM_H

typedef struct {
	int		ptype;	// magic number (integer part of 'P6')
	int		w;	// width
	int		h;	// height
	int		bpp;	// bytes per pixel (1 or 3)
	int		max;	// max color (usually 255)
	char		*name; 	// filename
	float		*rpix;	// red pixels, stored as 1D array
	float		*gpix;	// green pixels, stored as 1D array
	float		*bpix;	// blue pixels, stored as 1D array
} PPM;

PPM	*ppm_alloc(int r, int c);
void     ppm_free(PPM **img);
PPM     *ppm_read(const char *file);
int      ppm_write(PPM *img, const char *file);
void     ppm_white(PPM *img);

#endif
