#include <iostream>
#include <fstream>
#include <string>

#include "pgm.h"

int main()
{
       // call constructor with file name (that happens to exist)
       // intent: save "mandrill.pgm" as file name and open file
       pgm_t		org("mandrill.pgm");
       // call constructor with file name (that doesn't exist)
       // intent: save "gray.pgm" as file name but don't open file
       //         create 'empty' image with default w x h and name "gray.pgm"
       pgm_t		cpy("gray.pgm");

       // declare ofs of type std::ofstream (output file stream)
       std::ofstream	ofs;

  // open output file stream, of name "copy.pgm" in output and binary modes
  ofs.open("copy.pgm",std::ios::out | std::ios::binary);
  // write image 'org' to output using std::ofstream operator<<()
  ofs << org;
  // don't forget to close output file stream
  ofs.close();

  // copy image from org to cpy except for fname using copy assignment operator
  cpy = org;

  // open output file stream image using fname as the file name
  ofs.open(cpy.fname().c_str(),std::ios::out | std::ios::binary);
  ofs << cpy;
  ofs.close();

  return 0;
}
