#ifndef PGM_H
#define PGM_H

// forward declcarations
// (none)

class pgm_t {
       public:
       // constructors (overloaded)
       pgm_t(const char *file=NULL) : \
                            ptype(0), \
                            w(0), h(0), \
                            bpp(0), max(0), \
                            gpix(NULL)
                            {
                                   std::ifstream ifs;

                              // watch out for NULL file ptr, use "" instead
                              if(!file) name.assign("");
                              else {
                                name.assign(file);
                                ifs.open(file,std::ios::in|std::ios::binary);
                                if(ifs.good()) ifs >> this;
                                ifs.close();
                              }
                            };

       // copy constructor
       pgm_t(const pgm_t& rhs);

       // destructors
      ~pgm_t()                                          { if(gpix) {
                                                            delete [] gpix;
                                                          }
                                                        }

       // friends
friend std::istream& operator>>(std::istream& s, pgm_t& rhs);
friend std::istream& operator>>(std::istream& s, pgm_t *rhs)
                                                       { return(s >> (*rhs)); }
friend std::ostream& operator<<(std::ostream& s, const pgm_t& rhs);
friend std::ostream& operator<<(std::ostream& s, pgm_t *rhs)
                                                       { return(s << (*rhs)); }

       // operators
       const float&       operator[](int i) const       { return gpix[i]; }
       float&             operator[](int i)             { return gpix[i]; }

       // assignment operator
       const pgm_t&       operator=(const pgm_t&);

       // members
       std::string       fname()                       { return name; }
       void              rename(const char *file)      { name.assign(file); }
       
       // private: only available to this class
       private:
       int          ptype;
       int          w,h;
       int          bpp;
       int          max;
       std::string  name;
       float        *gpix;
};

#endif
