#ifndef PPM_H
#define PPM_H

// forward declcarations
class pgm_t;

class ppm_t : public pgm_t {
       public:
       ppm_t(const char *file) : \
//                          pgm_t(file)                 { } // init base class
                            pgm_t(file), \
                            rpix(NULL), \
                            bpix(NULL)
                            {
                                   std::ifstream ifs;

                              // watch out for NULL file ptr, use "" instead
                              if(!file) name.assign("");
                              else {
                                name.assign(file);
                                ifs.open(file,std::ios::in|std::ios::binary);
                                if(ifs.good()) ifs >> this;
                                ifs.close();
                              }
                            };

       // copy constructor
       ppm_t(const ppm_t& rhs);

       // destructors, base destructor called after
      ~ppm_t()              { if(rpix) {
                                delete [] rpix;
                              }
                              if(bpix) {
                                delete [] bpix;
                              }
                            }

       // friends
friend std::istream& operator>>(std::istream& s, ppm_t& rhs);
friend std::istream& operator>>(std::istream& s, ppm_t *rhs)
                                                       { return(s >> (*rhs)); }
friend std::ostream& operator<<(std::ostream& s, const ppm_t& rhs);
friend std::ostream& operator<<(std::ostream& s, ppm_t *rhs)
                                                       { return(s << (*rhs)); }

friend class pgm_t;

       // operators

       // assignment operator
       const ppm_t&       operator=(const ppm_t&);

       // private: only available to this class (extends base class)
       private:
       // red and blue channels...already have gpix
       float        *rpix;
       float        *bpix;
};

#endif
